package com.jqtx.windows.web.config;

import com.jqtx.windows.command.*;
import com.jqtx.windows.common.factory.AbstractCommand;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import java.util.HashMap;

@Component
@Slf4j
public class RouterConfig implements CommandLineRunner {


    @Autowired
    private CreditSubmitCommand creditSubmitCommand;
    @Autowired
    private LoanSubmitCommand loanSubmitCommand;
    @Autowired
    private LoanStatusCommand loanStatusCommand;
    @Autowired
    private GetCreditCommand getCreditCommand;
    @Autowired
    private SignContractCommand signContractCommand;
    @Autowired
    private SyncCreditCommand syncCreditCommand;
    @Autowired
    private SyncLoanCommand syncLoanCommand;
    @Autowired
    private SaveProtocolCommand saveProtocolCommand;
    @Autowired
    private BackedCommand backedCommand;


    private static HashMap<String, AbstractCommand> commandHashMap = new HashMap<>();

    public static AbstractCommand getCommand(String method) {
        if (!commandHashMap.containsKey(method)) {
            return null;
        }
        return commandHashMap.get(method);
    }

    @Override
    public void run(String... args) throws Exception {
        commandHashMap.put("creditSubmit", creditSubmitCommand);
        commandHashMap.put("getCredit",getCreditCommand);
        commandHashMap.put("loanSubmit", loanSubmitCommand);
        commandHashMap.put("getLoanResult", loanStatusCommand);
        commandHashMap.put("signContract",saveProtocolCommand);
        commandHashMap.put("getSignContract",signContractCommand);
        commandHashMap.put("syncLoan",syncLoanCommand);
        commandHashMap.put("syncCreditResult",syncCreditCommand);
        commandHashMap.put("syncBack",backedCommand);
    }
}
